Application: gvSIG desktop - gvSIG bugs #2794
Cambio en los tipos de geometria que introduce una incompatibilidad con versiones previas
08/19/2014 03:41 PM - Cesar Martinez lzquierdo
Description

Recientemente se ha introducido un cambio en los tipos de geometria (org.gvsig.fmap.geom.Geometry. TYPES), a los que se ha
anadido 2 nuevos tipos:

public final static int LINE = 11;

public final static int POLYGON = 12;

Este cambio introduce una incompatibilidad con versiones previas de la libreria, ya que los codigos 11 y 12 estaban anteriormente
reservados para CIRCLE y ARC, respectivamente.

Cualquier plugin que utilize Geometry. TYPES (con codigos superiores al 10) funcionara incorrectamente hasta que se actualice la
dependencia en el pom.xml del plugin a la dltima version de org.gvsig.desktop y se recompile dicho plugin.

Un ejemplo de dicho funcionamiento incorrecto es la herramienta de creacion de circulos en el documento Mapa (Layout), que no
funciona en los ultimos builds. Es posible que haya errores en otros plugins por el mismo motivo.

Un solucion seria restablecer los codigos originales, y afadir LINE y POLYGON usando cédigos no utilizados anteriormente (por
ejemplo 18y 19).

Otra solucion es actualizar la dependencia de todos los plugins a la Ultima version de org.gvsig.desktop y recompilarlos, pero es
dificil a priori detectar qué plugins estan afectados.

Related issues:
Related to Application: gvSIG desktop - gvSIG bugs # 2776: "Select by circle"... Invalid 08/06/2014
Related to Application: gvSIG desktop - gvSIG bugs # 2812: No carga WFS Closed 09/15/2014

Associated revisions

Revision 41690 - 09/03/2014 07:51 AM - Joaquin del Cerro Murciano

Cambiados los valores para las constantes de LINE y POLYGON en la clase Geometry para mantener compatibiliad binaria con los tipos que habian
antes ( refs #2794)

History

#1 - 08/20/2014 02:49 AM - Alvaro Anguix

Si es correcta y no tiene implicaciones la de afadir nuevos codigos, es preferible. Deberiamos intentar evitar incompatibilidades salvo en casos

necesarios. Mas aun si la otra opcion va a hacer que herramientas no controladas dejen de funcionar.
#2 - 08/20/2014 02:49 AM - Alvaro Anguix
- Target version set to 2.1.0-2259-rc3

#3 - 08/20/2014 05:06 AM - Antonio Falciano

Another example of incompatibility introduced by the recent geometry types changes could be #2776.

#4 - 08/20/2014 07:10 AM - Cesar Martinez Izquierdo

A ver qué opina Joaquin, ya que él hizo estos cambios.

Lo de usar cddigos mas altos sera similar a lo que hay ahora (ya que igualmente se afadieron 2 codigos) pero sin alterar los cédigos anteriores.

En cualquier caso creo que hay que repensar el cambio un poco mas a fondo, ya que me da la impresion de que los nuevos tipos LINE y POLYGON
son equivalentes a los ya existentes CURVE y SURFACE, y por tanto redundantes:

o>

* A straight or curved geometric element that is generated by a moving

* point and that has extension only along the path of the point.

*/
public final static int CURVE = 2;

Je

* A closed plane figure bounded by straight lines.
*/

public final static int SURFACE = 3;

#5 - 08/21/2014 03:36 AM - Alvaro Anguix
- Related to gvSIG bugs #2776: "Select by circle" draws a square and returns weird selections added

#6 - 09/03/2014 07:54 AM - Joaquin del Cerro Murciano
- Severity changed from Minor to Major
- Assignee set to Joaquin del Cerro Murciano

- Status changed from New to Fixed

No me di cuenta de las repercusiones del cambio.
De momento voy a poner los codigos 18 y 19 (como sugieres) a los nuevos tipos para minimizar los problemas.

Respecto a si son redundantes o no los nuevos tipos...

Ahora mismo tal como esta si, lo son.

En algun momento cuando se abordo el APl de geometrias se nos fue la olla a alguno
y se asumio que un Polygon es un Surface y que una Line es una Curve, y no es asi.
De hecho, en la implementacion eso habia causado errores importantes, y algunos
de ellos aun persisten.

Curve deberia ser un tipo de geometria no instanciable del que deriban Line o Arc,
y con Surface pasaria algo similar.

#7 - 09/08/2014 10:00 AM - Joaquin del Cerro Murciano
- Target version changed from 2.1.0-2259-rc3 to 2.1.0-2246-testing
#8 - 09/15/2014 03:45 AM - Alvaro Anguix
- Status changed from Fixed to Closed

#9 - 09/18/2014 11:10 AM - Joaquin del Cerro Murciano
- Related to gvSIG bugs #2812: No carga WFS added
